<TeXmacs|1.0>

<style|letter>

<\body>
  <section|Limitations>

  No student model (-\<gtr\> guidance, choosing exercises)

  Simple interaction model (write a program, push the button, get feedback)

  No interface for the creation of new exercises / modification of the type
  information

  No natural-language feedback for recursive programs (yet)

  PLHT is not really ready for production use (XPCE web server has single
  threading, PLHT not thread safe, so it cannot be used with the threading
  web server)

  Sessions never time out

  Syntax analysis sometimes fails because the search space grows too big
  (closing paren can be inserted in multiple places...)

  confusion of variables and atoms (X -\<gtr\> x): find a rule that is not
  too general...

  no <verbatim|not/1>, no cut (<verbatim|!/0>)

  the name and places of the user solution have to exactly match those of the
  sample solution

  make it possible to leave some freedom in the implementation

  <section|Future developments>

  integrate syntax analysis with the type checker to choose one from several
  possibilities

  as in: <verbatim|ausleihe(2264,a1234,d(1,1,2003,0,nein)<verbatim|<verbatim|\
  >>>

  fancy testing: graft a (partial) trace from the sample solution and see if
  this makes the trace correct

  try to construct invariants (peano_add...)

  is it possible to use heuristics to improve the speed of
  <verbatim|ids_search>?

  integrate <name|Luse> into the <name|swi> emacs editor

  extend to other languages (<name|Sql>, <name|Pl-Sql>, <name|Scheme>)
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|page type|a4>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|25mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      Limitations<value|toc-dots><pageref|toc-1>

      Future developments<value|toc-dots><pageref|toc-2>
    </associate>
  </collection>
</auxiliary>
