:- set_domain(bib).


type_decl(buch(signatur,autor,titel,standort)).
type_decl(ausleihe(leserNr,signatur,datum,anzahl,janein)).
type_decl(vorbestellung(leserNr,signatur,datum)).
type_decl(leser(leserNr,nachname,vorname,adresse,jahr)).

enum_decl(leserNr, [2264, 3167, 4238]).
enum_decl(vorname, [gabi, hans, michael]).
enum_decl(adresse, [modderkamp_13, ossenpad_35, upn_barg_28]).

%enum_wildcard(adresse, '[a-z]*_[0-9][0-9]').
enum_decl(datum, [d(tag, monat, jahr)]).
enum_decl(signatur, [a2251, a3325, b3948, b4672, c5674]).
%enum_wildcard(signatur, '[a-z][0-9][0-9][0-9][0-9]').
enum_decl(nachname, [hauptmann, hiller, kahl,
		     kohler, meyer, mohnhaupt_paulsen,
		     mueller, scholz]).
enum_decl(titel, [das_schicksal_grosser_denker,
		      der_mensch_und_das_chaos,
		      mensch_aergere_dich_nicht,
		      reich_werden_kein_problem,
		      vom_sinn_und_unsinn]).
enum_decl(standort, [lesesaal, magazin, regal113, regal117]).
enum_decl(janein, [ja, nein]).


:- dynamic range_type/3.
:- multifile range_type/3.

range_decl(tag, 1, 31).
range_decl(monat, 1, 12).
range_decl(jahr, 1900, 2050).
range_decl(anzahl,0,9).
%range_type(kalenderwoche, 1, 53).










