<TeXmacs|1.0>

<style|letter>

<\body>
  <\enumerate>
    <item>Problem description

    Many Informatics students have probem with learning programming,
    especially logic programming. With the project LuSe we want to attain the
    following aims:

    <\expand|itemize-minus>
      <item>find out the typical difficutlties which a novice programmer
      normally has to meet.

      <item>build a web-based environment that reads the approach to a
      specified problem of the student and analyse his/her solution.

      <item>generate the appropriate feedbacks which correspond to the
      concept of the programming. With the feedbacks the student can improve
      his/her solution successively and override the blockades of learning
      programming in the early phase.
    </expand>

    <item>Solution

    The architecture of LuSe is devided into three layers: frontend, backend
    and resource layer. Frontend is responsible for reading solutions to a
    described exercise and representing the feedbacks.\ 

    Frontend works on the HTTP server of SWI-Prolog and is supported by the
    PLHT (see PLHT documentation) library written by Yannick Versley. PLHT is
    an approach similar to Java Server Pages that tries to make seperation of
    presentation and application logic possible for applications written in
    Prolog.

    Backend analyses student's solution and generate diagnose by comparing
    this solution with a sample solution. At present we just have one sample
    solution for one exercise. The diagnotisation goes through following
    components: normalizer, syntax checker, type checker, and analyzer. The
    normalizer brings the student solution back to the normal form. The
    syntax cheker verifies the student's input if it is syntax conform. The
    semantic cheking begins with type checker which examines the type using
    in the input. Semantic errors will be found by the analyse components as
    Auswertung, Idiom, Test enigne. Backend uses a base library of session
    management, iterative deepening search and feedback generation.

    The resource layer contains exercise descriptions and sample solutions
    which are saved in form of XML files and Prolog database.

    <item>Limitations and future works
  </enumerate>

  \;

  \;
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|page type|a4>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|25mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
    <associate|language|english>
  </collection>
</initial>
