% we declare the possible types of haeuser domain.
% three types: enum, range, type_decl(predicates).

type_decl(obj(objektNr,objektTyp,strassenname,hausnummer,jahr)).
type_decl(bew(vorgangsNr,objektNr,person,person,preis,datum)).
type_decl(datum@<datum).
type_decl(datum@=<datum).
type_decl(datum@>datum).
type_decl(datum@>=datum).

enum_decl(datum, [d(jahr,monat,tag)]).
enum_decl(objektNr,[o1,o2,o3,o4,o5,o6,o7]).
enum_decl(vorgangsNr,[b1,b2,b3,b4,b5,b6,b7]).
enum_decl(objektTyp,[efh,mfh,bahnhof,kaufhaus]).
enum_decl(strassenname,[gaertnerstr,bahnofsstr]).
enum_decl(person,[mueller,meier,schulze,schneider,bund,piepenbrink]).

range_decl(tag, 1, 31).
range_decl(monat, 1, 12).
range_decl(jahr, 1900, 2050).
range_decl(hausnummer,1,30).
range_decl(preis,400000,4000000).

% simplify(Dat1@>Dat2,Dat2@<Dat1).
instantiation_sensitive(@<).
instantiation_sensitive(@=<).
instantiation_sensitive(@>).
instantiation_sensitive(@>=).
